--
--
--		MapAmpeln_Kreuzung4er
--@date: 02/10/2012
--@Author: Bluebaby210		www.mod-portal.com
--@Version: v1.0
--
--darf in jede Map eingebaut werden, MapAmpeln.zip darf nicht neu hochgeladen werden
--
--Keine nderung ohne meine Erlaubnis
--No modification without my permission


	print("   Map: TrafficLights 4er v1.0 by Bluebaby210 loaded!");

function onCreateKreuzung4er(self, id)
	--print("created MapAmpeln4er, id: ", id);
	local Ampeln4 = kreuzung4er:new(g_server ~= nil, g_client ~= nil);
    local index = g_currentMission:addOnCreateLoadedObject(Ampeln4);
    Ampeln4:load(id);
    Ampeln4:register(true);
end;

kreuzung4er = {}
local kreuzung4er_mt = Class(kreuzung4er, Object);

function kreuzung4er:new(isServer, isClient)
    local self = Object:new(isServer, isClient, kreuzung4er_mt);
    self.className = "kreuzung4er";
    return self;
end;

function kreuzung4er:load(id)

	--Indexe der Lampen laden
	self.red41 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.1_Red"));
	self.red42 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.2_Red"));
	self.red43 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.3_Red"));
	self.red44 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.4_Red"));

	self.orange41 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.1_Orange"));
	self.orange42 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.2_Orange"));
	self.orange43 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.3_Orange"));
	self.orange44 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.4_Orange"));

	self.green41 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.1_Green"));
	self.green42 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.2_Green"));
	self.green43 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.3_Green"));
	self.green44 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.4_Green"));
	
	
	--Collis Laden und collis hochsetzen sowie g_currentMission.nodeToVehicles setzen.
	self.colli41 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.1_Colli"));
	self.colli42 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.2_Colli"));
	self.colli43 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.3_Colli"));
	self.colli44 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights4.4_Colli"));

	x41, y41, z41 = getTranslation(self.colli41);
	x42, y42, z42 = getTranslation(self.colli42);
	x43, y43, z43 = getTranslation(self.colli43);
	x44, y44, z44 = getTranslation(self.colli44);
	
	setTranslation(self.colli41,x41, 0, z41);
	g_currentMission.nodeToVehicle[self.colli41] = {};
	setTranslation(self.colli42,x42, 0, z42);
	g_currentMission.nodeToVehicle[self.colli42] = {};
	setTranslation(self.colli43,x43, 0, z43);
	g_currentMission.nodeToVehicle[self.colli43] = {};
	setTranslation(self.colli44,x44, 0, z44);
	g_currentMission.nodeToVehicle[self.colli44] = {};

	--greenTime laden berprfen ob mich jemand "verarscht", zur not grnphasen an der falsch eingestellten Kreuzung gleich auf 5 sekunden setzen.
	self.greenTime41 = getUserAttribute(id, "TrafficLights4.1_greenTime");
	self.greenTime42 = getUserAttribute(id, "TrafficLights4.2_greenTime");
	self.greenTime43 = getUserAttribute(id, "TrafficLights4.3_greenTime");
	self.greenTime44 = getUserAttribute(id, "TrafficLights4.4_greenTime");
	
	if self.greenTime41 < 5 or self.greenTime42 < 5 or self.greenTime43 < 5 or self.greenTime44 < 5 then
		self.greenTime41 = 5;
		self.greenTime42 = 5;
		self.greenTime43 = 5;
		self.greenTime44 = 5;
		print ("Warning: Gruenphase in einer Ampel kleiner als 5Sek. oder nicht angegeben, Gruenphase in allen Ampeln der Kreuzung auf 5Sekunden gesetzt");
	end;
	
	--Timer grnphasen hochsetzen um Pausen fr die umschaltung der nchsten Ampel erstellen zu knnen. Sowie blinklicht timer fr ausgeschaltete ampeln laden.
	self.TimerGreen41 = (self.greenTime41 * 1000) + 10000;
	self.TimerGreen42 = (self.greenTime42 * 1000) + 6000;
	self.TimerGreen43 = (self.greenTime43 * 1000) + 6000;
	self.TimerGreen44 = (self.greenTime44 * 1000) + 2000;
	self.TimerGreen41Backup = self.TimerGreen41;
	self.TimerGreen42Backup = self.TimerGreen42;
	self.TimerGreen43Backup = self.TimerGreen43;
	self.TimerGreen44Backup = self.TimerGreen44;
	self.TrafficLights42start = false;
	self.TrafficLights43start = false;
	self.TrafficLights44start = false;
	self.sequenceIsInterrupted = true;
	self.orangeFlashing = true;
	self.orangeLightTimer = 2000;
	self.orangeLightTimerBackup = 2000;
	
	--Zeitsteuerung
	self.trafficLightsStartTime = getUserAttribute(id, "TrafficLights_start_time");
	if self.trafficLightsStartTime == 0 then
		self.trafficLightsStartTime = 0.01;
	end;
	self.trafficLightsEndTime = getUserAttribute(id, "TrafficLights_end_time");
	if self.trafficLightsEndTime == 0 then
		self.trafficLightsEndTime = 23.99;
	end;
	
	self.startTime = self.trafficLightsStartTime * 3600000;
	self.endTime = self.trafficLightsEndTime * 3600000;

	self.allowsControl = true;
	
	if self.isServer then
		if g_server.netIsRunning then
			self.allowsControl = false;
			globaleVariable = false;
			globaleTriggerVariable = false;
		end;
	end;
	
	if g_client.netIsRunning == true then
		self.allowsControl = false;
		globaleVariable = false;
		globaleTriggerVariable = false;
	end;
	
	self.MpStarted = 0;

end;

function kreuzung4er:delete()
end;

function kreuzung4er:mouseEvent(posX, posY, isDown, isUp, button)
end;

function kreuzung4er:keyEvent(unicode, sym, modifier, isDown)
end;

function kreuzung4er:TriggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)

end;

function kreuzung4er:update(dt)

	if (g_currentMission.environment.dayTime > self.startTime and g_currentMission.environment.dayTime < self.endTime) then
		if globaleVariable then				--ampeln sind an, "globaleVariable" kommt aus dem Trigger skript
				self.orangeFlashing = true;					--wird gebraucht um beim abschalten alle collis runterzufahren und die Lampen auszuschalten, sowie alle Timer der Ampelphasen zurckzusetzen. 
			if self.sequenceIsInterrupted then					--wenn Ampeln ausgeschaltet waren, einmal durchlaufen um Ampel auf rot zu stellen und collis hochholen
				setVisibility(self.red41,true);
				setVisibility(self.red42,true);
				setVisibility(self.red43,true);
				setVisibility(self.red44,true);
				setVisibility(self.orange41,false);
				setVisibility(self.orange42,false);
				setVisibility(self.orange43,false);
				setVisibility(self.orange44,false);
				setVisibility(self.green41,false);
				setVisibility(self.green42,false);
				setVisibility(self.green43,false);
				setVisibility(self.green44,false);
				setTranslation(self.colli41,x41, 0, z41);
				setTranslation(self.colli42,x42, 0, z42);
				setTranslation(self.colli43,x43, 0, z43);
				setTranslation(self.colli44,x44, 0, z44);
				self.sequenceIsInterrupted = false;
			end;
			if self.TimerGreen41 >= 0 then					--1.Ampel startet mit durchlauf
				self.TimerGreen41 = self.TimerGreen41 - dt;
					if self.TimerGreen41 <= (self.TimerGreen41Backup - 4000) and self.TimerGreen41 >= (self.TimerGreen41Backup - 5000) then		--nach 4 sekunden pause, wird gelb fr eine sek gesetzt
						setVisibility(self.orange41,true);
					elseif self.TimerGreen41 <= (self.TimerGreen41Backup - 5000) and self.TimerGreen41 >= ((self.TimerGreen41Backup + 5000) - self.TimerGreen41Backup) then	--grnphase der ampel
						setVisibility(self.red41,false);
						setVisibility(self.orange41,false);
						setVisibility(self.green41,true);
						setTranslation(self.colli41,x41, -5, z41);
					elseif self.TimerGreen41 <= ((self.TimerGreen41Backup + 5000) - self.TimerGreen41Backup) and self.TimerGreen41 >= ((self.TimerGreen41Backup + 4000) - self.TimerGreen41Backup) then	--gelb
						setVisibility(self.green41,false);
						setVisibility(self.orange41,true);
					elseif self.TimerGreen41 <= ((self.TimerGreen41Backup + 4000) - self.TimerGreen41Backup) and self.TimerGreen41 >= 0 then	--4 sekunden rot, um kreuzung frei zu kriegen
						setVisibility(self.orange41,false);
						setVisibility(self.red41,true);
						setTranslation(self.colli41,x41, 0, z41);
					elseif self.TimerGreen41 <= 0 then		--erst wenn Timer ganz abgelaufen kommt startbefehl fr 2.ampel
						self.TrafficLights42start = true;
					end;
				end;
			if self.TrafficLights42start then
				if self.TimerGreen42 >= 0 then
					self.TimerGreen42 = self.TimerGreen42 - dt;
						if self.TimerGreen42 <= self.TimerGreen42Backup and self.TimerGreen42 >= (self.TimerGreen42Backup - 1000) then		--1.sekunde gelb anzeigen
							setVisibility(self.orange42,true);
						elseif self.TimerGreen42 <= (self.TimerGreen42Backup - 1000) and self.TimerGreen42 >= ((self.TimerGreen42Backup + 5000) - self.TimerGreen42Backup) then	--grnphase
							setVisibility(self.red42,false);
							setVisibility(self.orange42,false);
							setVisibility(self.green42,true);
							setTranslation(self.colli42,x42, -5, z42);
						elseif self.TimerGreen42 <= ((self.TimerGreen42Backup + 5000) - self.TimerGreen42Backup) and self.TimerGreen42 >= ((self.TimerGreen42Backup + 4000) - self.TimerGreen42Backup) then --gelb
							setVisibility(self.green42,false);
							setVisibility(self.orange42,true);
						elseif self.TimerGreen42 <= ((self.TimerGreen42Backup + 4000) - self.TimerGreen42Backup) and self.TimerGreen42 >= 0 then	--4sekunden rot,  um kreuzung frei zu kriegen
							setVisibility(self.orange42,false);
							setVisibility(self.red42,true);
							setTranslation(self.colli42,x42, 0, z42);
						elseif self.TimerGreen42 <= 0 then	--erst wenn timer 0, kommt befehl fr 3.Ampel
							self.TrafficLights43start = true;
							self.TrafficLights42start = false;
							self.TimerGreen42 = self.TimerGreen42Backup;
						end;
				end;
			end;
			--
			if self.TrafficLights43start then
				if self.TimerGreen43 >= 0 then
					self.TimerGreen43 = self.TimerGreen43 - dt;
						if self.TimerGreen43 <= self.TimerGreen43Backup and self.TimerGreen43 >= (self.TimerGreen43Backup - 1000) then		--1.sekunde gelb anzeigen
							setVisibility(self.orange43,true);
						elseif self.TimerGreen43 <= (self.TimerGreen43Backup - 1000) and self.TimerGreen43 >= ((self.TimerGreen43Backup + 5000) - self.TimerGreen43Backup) then	--grnphase
							setVisibility(self.red43,false);
							setVisibility(self.orange43,false);
							setVisibility(self.green43,true);
							setTranslation(self.colli43,x43, -5, z43);
						elseif self.TimerGreen43 <= ((self.TimerGreen43Backup + 5000) - self.TimerGreen43Backup) and self.TimerGreen43 >= ((self.TimerGreen43Backup + 4000) - self.TimerGreen43Backup) then --gelb
							setVisibility(self.green43,false);
							setVisibility(self.orange43,true);
						elseif self.TimerGreen43 <= ((self.TimerGreen43Backup + 4000) - self.TimerGreen43Backup) and self.TimerGreen43 >= 0 then	--4sekunden rot,  um kreuzung frei zu kriegen
							setVisibility(self.orange43,false);
							setVisibility(self.red43,true);
							setTranslation(self.colli43,x43, 0, z43);
						elseif self.TimerGreen43 <= 0 then	--erst wenn timer 0, kommt befehl fr 4.Ampel
							self.TrafficLights44start = true;
							self.TrafficLights43start = false;
							self.TimerGreen43 = self.TimerGreen43Backup;
						end;
				end;
			end;

			if self.TrafficLights44start then
				if self.TimerGreen44 >= 0 then
					self.TimerGreen44 = self.TimerGreen44 - dt;
						if self.TimerGreen44 <= self.TimerGreen44Backup and self.TimerGreen44 >= (self.TimerGreen44Backup - 1000) then		--1.sekunde gelb anzeigen
							setVisibility(self.orange44,true);
						elseif self.TimerGreen44 <= (self.TimerGreen44Backup - 1000) and self.TimerGreen44 >= ((self.TimerGreen44Backup + 1000) - self.TimerGreen44Backup) then	--grnphase
							setVisibility(self.red44,false);
							setVisibility(self.orange44,false);
							setVisibility(self.green44,true);
							setTranslation(self.colli44,x44, -5, z44);
						elseif self.TimerGreen44 <= ((self.TimerGreen44Backup + 1000) - self.TimerGreen44Backup) and self.TimerGreen44 >= 0 then	--gelb
							setVisibility(self.green44,false);
							setVisibility(self.orange44,true);
						elseif self.TimerGreen44 <= 0 then		--keine 4 sekunden pause, da 4sekunden pause zu beginn der 1.Ampel gemacht werden, damit auch nach anschalten der ampeln 4 sek rot ist.
							setVisibility(self.orange44,false);
							setVisibility(self.red44,true);
							setTranslation(self.colli44,x44, 0, z44);
							self.TrafficLights44start = false;
							self.TimerGreen41 = self.TimerGreen41Backup;
							self.TimerGreen44 = self.TimerGreen44Backup;
						end;
				end;
			end;

		end;
	 
		if globaleVariable == false then		--ampeln sind ausgeschaltet
			if self.orangeFlashing then			--einmal durchlaufen, dabei timer der ampeln zurcksetzen, collis runterfahren, lampen rot und grn ausschalten, sowie startbefehl fr Blinklicht geben, Timer setzen.
				self.TimerGreen41 = self.TimerGreen41Backup;
				self.TimerGreen42 = self.TimerGreen42Backup;
				self.TimerGreen43 = self.TimerGreen43Backup;
				self.TimerGreen44 = self.TimerGreen44Backup;
				self.TrafficLights42start = false;
				self.TrafficLights43start = false;
				self.TrafficLights44start = false;
				setTranslation(self.colli41,x41, -5, z41);
				setTranslation(self.colli42,x42, -5, z42);
				setTranslation(self.colli43,x43, -5, z43);
				setTranslation(self.colli44,x44, -5, z44);
				setVisibility(self.red41,false);
				setVisibility(self.red42,false);
				setVisibility(self.red43,false);
				setVisibility(self.red44,false);
				setVisibility(self.green41,false);
				setVisibility(self.green42,false);
				setVisibility(self.green43,false);
				setVisibility(self.green44,false);
				self.orangeFlashing = false;
				self.sequenceIsInterrupted = true;
				self.orangeLightTimer = self.orangeLightTimerBackup;
			end;
			
			if self.orangeFlashing == false then
				if self.orangeLightTimer >= 0 then		--Timer laufen lassen, 1sekunde an, 1.sek aus...Timer wieder zurcksetzen um neuen durchlauf zu starten
					self.orangeLightTimer = self.orangeLightTimer - dt;
					if self.orangeLightTimer <= 2000 and self.orangeLightTimer >= 1000 then
						setVisibility(self.orange41,false);
						setVisibility(self.orange42,false);
						setVisibility(self.orange43,false);
						setVisibility(self.orange44,false);
					elseif self.orangeLightTimer <= 1000 and self.orangeLightTimer >= 0 then
						setVisibility(self.orange41,true);
						setVisibility(self.orange42,true);
						setVisibility(self.orange43,true);
						setVisibility(self.orange44,true);
					elseif self.orangeLightTimer <= 0 then
						self.orangeLightTimer = self.orangeLightTimerBackup;
					end;
				end;
			end;
		end;
	elseif (g_currentMission.environment.dayTime >= self.endTime or g_currentMission.environment.dayTime <= self.startTime) then
			if self.orangeFlashing then			--einmal durchlaufen, dabei timer der ampeln zurcksetzen, collis runterfahren, lampen rot und grn ausschalten, sowie startbefehl fr Blinklicht geben, Timer setzen.
				self.TimerGreen41 = self.TimerGreen41Backup;
				self.TimerGreen42 = self.TimerGreen42Backup;
				self.TimerGreen43 = self.TimerGreen43Backup;
				self.TimerGreen44 = self.TimerGreen44Backup;
				self.TrafficLights42start = false;
				self.TrafficLights43start = false;
				self.TrafficLights44start = false;
				setTranslation(self.colli41,x41, -5, z41);
				setTranslation(self.colli42,x42, -5, z42);
				setTranslation(self.colli43,x43, -5, z43);
				setTranslation(self.colli44,x44, -5, z44);
				setVisibility(self.red41,false);
				setVisibility(self.red42,false);
				setVisibility(self.red43,false);
				setVisibility(self.red44,false);
				setVisibility(self.green41,false);
				setVisibility(self.green42,false);
				setVisibility(self.green43,false);
				setVisibility(self.green44,false);
				self.orangeFlashing = false;
				self.sequenceIsInterrupted = true;
				self.orangeLightTimer = self.orangeLightTimerBackup;
			end;
			if self.orangeFlashing == false then
				if self.orangeLightTimer >= 0 then		--Timer laufen lassen, 1sekunde an, 1.sek aus...Timer wieder zurcksetzen um neuen durchlauf zu starten
					self.orangeLightTimer = self.orangeLightTimer - dt;
					if self.orangeLightTimer <= 2000 and self.orangeLightTimer >= 1000 then
						setVisibility(self.orange41,false);
						setVisibility(self.orange42,false);
						setVisibility(self.orange43,false);
						setVisibility(self.orange44,false);
					elseif self.orangeLightTimer <= 1000 and self.orangeLightTimer >= 0 then
						setVisibility(self.orange41,true);
						setVisibility(self.orange42,true);
						setVisibility(self.orange43,true);
						setVisibility(self.orange44,true);
					elseif self.orangeLightTimer <= 0 then
						self.orangeLightTimer = self.orangeLightTimerBackup;
					end;
				end;
			end;
		end;
	
	if not self.allowsControl then
		if self.MpStarted < 4000 then
			g_currentMission:addWarning(g_i18n:getText("Ampel_MP_W"));
			self.MpStarted = self.MpStarted + dt;
		end;
	end;

end;

function kreuzung4er:draw()
end;
addModEventListener(MapAmpelnkreuzung4er);


